#line 1 "C:/_MikroC/_MesProjets_MikroC/_16F1619_TEST_HEF/HEF_Mkroe_Ex/Flash_test_MikroE_rev1.c"
#line 23 "C:/_MikroC/_MesProjets_MikroC/_16F1619_TEST_HEF/HEF_Mkroe_Ex/Flash_test_MikroE_rev1.c"
sbit Led_Rouge at LATA.B4;
sbit Led_Rouge_Dir at TRISA.B4;
sbit SQA at LATC.B5;
sbit SQA_Dir at TRISC.B5;
sbit Led_Bleue at LATC5_bit;
sbit HEF_Ecrit at PORTC.B1;
sbit HEF_Ecrit_Dir at TRISC.B1;


char i = 0;
unsigned int addr, data_, dataAR[32];
char txtUart[60];


char TEXTE[80];
char *p1=&TEXTE[0];

void Init_Hardware(void) ;
void strConstRamCpy(unsigned char *dest, const code char *source);
void Init_Hardware(void) ;
void CRLF1(void);
void UART1_Write_CText(const char *txt);
void Config_PPS(void);



void strConstRamCpy(unsigned char *dest, const code char *source)
 {
 while (*source)*dest++ = *source++ ;
 *dest = 0 ;
}




void CRLF1()
{
 UART1_Remappable_Write( 13 );
 UART1_Remappable_Write( 10 );
}

void CPrint(const char *txt)
 {
 while (*txt)
 UART1_Remappable_Write(*txt++);
 Delay_us(5);
}

void Config_PPS(void)
{
 Unlock_IOLOCK();
 RC5PPS=0;
 RA4PPS=0;






 RB5PPS = 0x0D;
 RB7PPS= 0x12;








 RB6PPS = 0x10;
 RB4PPS = 0x11;


 SSPCLKPPS = 0x0E;

 SSPDATPPS = 0x0C;
 RC5PPS=0;
 RA4PPS=0;
 Lock_IOLOCK();
}


 void Init_Hardware()
{

 BORCON.SBOREN=0;

 ANSELA=0;
 TRISA=0xFF;
 Led_Rouge_Dir=0;
 Led_Rouge=0;

 ANSELB=0;
 TRISB=0b11111111;

 WPUB=0 ;

 ODCONB.B4 = 1;
 ODCONB.B6 = 1;
 ODCONB.B5 = 0;
 ODCONB.B7 = 0;

 SLRCONB=0xF0;
 INLVLB=00;

 ANSELC=0;
 TRISC=0b11011111;
 WPUC=0b00100010 ;

 ODCONC.B5 = 1;




 OPTION_REG.nWPUEN =0;

 }


 void Init_Fosc(void)
 {

 OSCCON=0;

 OSCCON.IRCF3=1;
 OSCCON.IRCF2=1;
 OSCCON.IRCF1=1;
 OSCCON.IRCF0=1;

 OSCCON.SCS1=1;
 OSCTUNE=0;
 }

void main() {
#line 175 "C:/_MikroC/_MesProjets_MikroC/_16F1619_TEST_HEF/HEF_Mkroe_Ex/Flash_test_MikroE_rev1.c"
 *p1=&TEXTE[0];
 Init_Fosc();



 Init_Hardware() ;
 Config_PPS();

 UART1_Remappable_Init(19200);
 CPrint("\r\n FLASH TEST (HEF) 16F1619 \r\n");
 Delay_ms(100);

 addr = 0x1F80;
 strConstRamCpy(p1,"ABC123456DEFGH0123456789ABCDEFGHIJKLMNOPQ");
 CPrint(" Ecrit 32 data  partir de 0x1F80\r\n");

 for (i = 0; i < 32; i++){
 dataAR[i] =*(p1+i);
 }
 FLASH_Write(addr, &dataAR[0]);
 Delay_ms(100);

 CPrint(" Ecrit 32 data  partir de 0x1FA0\r\n");

 for (i = 0; i < 32; i++){
 dataAR[i] = addr+32+i;
 }
 FLASH_Write(addr+32, &dataAR[0]);
 Delay_ms(100);

 CPrint(" Ecrit 32 data  partir de 0x1FC0\r\n");
 for (i = 0; i < 32; i++){
 dataAR[i] = addr+64+i;
 }
 FLASH_Write(addr+64, &dataAR[0]);
 Delay_ms(100);

 CPrint(" Ecrit 32 data  partir de 0x1FE0\r\n");
 for (i = 0; i < 32; i++){
 dataAR[i] = addr+96+i;
 }
 FLASH_Write(addr+96, &dataAR[0]);
 Delay_ms(100);

 CPrint(" Relecture de 128 bytes  partir de 0x1F80\r\n");
 for (i = 0; i < 128; i++){
 data_ = FLASH_Read(addr++);
 Delay_us(10);
 WordToHex(data_, txtUart);
  UART1_Write_Text (txtUart);
 CRLF1();



 Delay_ms(50);
 }
}
